export declare type UseAsyncProps<ResultSchema = any, ExecPayload = any> = {
    fn: (props: ExecPayload) => any | ((props: ExecPayload) => Promise<any>);
    autoExec?: boolean;
    defaultData?: ResultSchema;
    defaultPayload?: ExecPayload;
    additionalPayload?: ExecPayload;
    onResult?: (result: ResultSchema) => any;
    onError?: (error: any) => any;
    onLoading?: (loading: boolean) => any;
};
export declare type UseAsyncReturn<ResultSchema = any, ExecPayload = any> = {
    loading: boolean;
    error: any;
    result: ResultSchema;
    exec: (payload?: ExecPayload | undefined) => void;
};
/**
 * @example
 * const promise = useAsync({
 * fn
 * })
 */
export default function useAsync<ResultSchema, ExecPayload>({ fn, autoExec, defaultData, defaultPayload, additionalPayload, onResult, onError, onLoading, }: UseAsyncProps<ResultSchema, ExecPayload>): UseAsyncReturn<ResultSchema, ExecPayload>;
